clients/urls.py
from django.urls import path
from django.utils.translation import gettext_lazy as _

from . import views

urlpatterns = [
    path('<int:pk>/', views.ClientUpdate.as_view(),
         name='client-update'),
    path(_('<int:pk>/delete/'), views.ClientDelete.as_view(),
         name='client-delete'),
    path('', views.clients_view, name='clients'),
]

programari/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.i18n import i18n_patterns
from django.utils.translation import gettext_lazy as _

urlpatterns = []

urlpatterns += i18n_patterns(
    path('admin/', admin.site.urls),
    path('', include(('homepage.urls', 'homepage'),
                     namespace='homepage')),
    path(_('providers/'), include(('providers.urls', 'providers'),
                                  namespace='providers')),
    path(_('services/'), include(('services.urls', 'services'),
                                 namespace='services')),
    path(_('clients/'), include(('clients.urls', 'clients'),
                                namespace='clients')),
    path(_('accounts/'), include(('accounts.urls', 'accounts'),
                                 namespace='accounts'))
)

services/urls.py
from django.urls import path
from django.utils.translation import gettext_lazy as _

from . import views

urlpatterns = [
    path('<int:pk>/', views.ServiceUpdate.as_view(),
         name='service-update'),
    path(_('<int:pk>/delete/'), views.ServiceDelete.as_view(),
         name='service-delete'),
    path('', views.services_view, name='services'),
]

homepage/models.py
from django.db import models
from django.utils import timezone
from django.urls import reverse
from django.contrib.auth.models import User
from datetime import timedelta
from django.utils.translation import gettext_lazy as _


class Service(models.Model):
    name = models.CharField(_('name'), max_length=200)
    price = models.DecimalField(_('price'),
                                max_digits=10, decimal_places=2,
                                blank=True, null=True)
    duration = models.TimeField(_('duration'), blank=True,
                                default='00:30')
    user = models.ForeignKey(
        User, on_delete=models.CASCADE, verbose_name=_('user'))

    class Meta:
        verbose_name = _('service')
        verbose_name_plural = _('services')

    def __str__(self):
        return f'{self.name.capitalize()}'

    def get_absolute_url(self):
        return reverse('services:services')


class WorkingPlan(models.Model):
    time_start = '00:00'
    time_end = '23:59'

    monday_start = models.TimeField(default=time_start)
    monday_end = models.TimeField(default=time_end)
    tuesday_start = models.TimeField(default=time_start)
    tuesday_end = models.TimeField(default=time_end)
    wednesday_start = models.TimeField(default=time_start)
    wednesday_end = models.TimeField(default=time_end)
    thursday_start = models.TimeField(default=time_start)
    thursday_end = models.TimeField(default=time_end)
    friday_start = models.TimeField(default=time_start)
    friday_end = models.TimeField(default=time_end)
    saturday_start = models.TimeField(default=time_start)
    saturday_end = models.TimeField(default=time_end)
    sunday_start = models.TimeField(default=time_start)
    sunday_end = models.TimeField(default=time_end)


class Provider(models.Model):
    first_name = models.CharField(_('first name'), max_length=50)
    last_name = models.CharField(_('last name'), max_length=50)
    services = models.ManyToManyField(Service, verbose_name=_('services'))
    user = models.ForeignKey(
        User, on_delete=models.CASCADE, verbose_name=_('user'))
    working_plan = models.OneToOneField(
        WorkingPlan, on_delete=models.PROTECT, verbose_name=_('working plan'))

    class Meta:
        verbose_name = _('provider')
        verbose_name_plural = _('providers')

    def __str__(self):
        return f'{self.first_name.capitalize() + " " + self.last_name.capitalize()}'

    def get_absolute_url(self):
        return reverse('providers:providers')


class Break(models.Model):

    DAYS_OF_WEEK = (
        ('monday', _('Monday')),
        ('tuesday', _('Tuesday')),
        ('wednesday', _('Wednesday')),
        ('thursday', _('Thursday')),
        ('friday', _('Friday')),
        ('saturday', _('Saturday')),
        ('sunday', _('Sunday'))
    )
    day = models.CharField(_('day'), max_length=20, choices=DAYS_OF_WEEK)
    time_begin = models.TimeField(_('time begin'))
    time_end = models.TimeField(_('time end'))
    provider = models.ForeignKey(
        Provider, on_delete=models.CASCADE, verbose_name=_('provider'))

    class Meta:
        verbose_name = _('break')
        verbose_name_plural = _('breaks')

    def __str__(self):
        return '{0}: {1} - {2}'.format(
            self.day.capitalize(),
            self.time_begin.strftime("%H:%M"),
            self.time_end.strftime("%H:%M"))


class Client(models.Model):
    first_name = models.CharField(_('first name'), max_length=50)
    last_name = models.CharField(_('last name'), max_length=50)
    date_time = models.DateTimeField(_('date and time'), default=timezone.now)
    email = models.EmailField(blank=True)
    user = models.ForeignKey(
        User, on_delete=models.CASCADE, verbose_name=_('user'))
    service = models.ForeignKey(Service,
                                on_delete=models.CASCADE,
                                verbose_name=_('service'))
    provider = models.ForeignKey(Provider,
                                 on_delete=models.CASCADE,
                                 verbose_name=_('provider'))

    class Meta:
        verbose_name = _('client')
        verbose_name_plural = _('clients')

    def __str__(self):
        if (type(self.date_time) != str):
            return f'{self.first_name.capitalize()}-{self.last_name.capitalize()} {self.date_time.strftime("%Y-%m-%d %H:%M")}'
        else:
            return f'{self.first_name.capitalize()}-{self.last_name.capitalize()} {self.date_time}'

    def get_absolute_url(self):
        return reverse('clients:clients')

    def get_date(self):
        """Return the client's appointment date."""
        return '%s' % (self.date_time)

    def get_full_name(self):
        """Return the client's full name."""
        return '%s %s' % (self.first_name.capitalize(),
                          self.last_name.capitalize())


# TODO: Do not leave blank=True or null=True in production

services/models.py
from django.db import models

# Create your models here.

services/views.py
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views.generic import DeleteView, UpdateView
from django.http import HttpResponseRedirect

from homepage.models import Service
from homepage.forms import ServiceForm


def services_view(request):

    services = Service.objects.all()
    user = request.user

    # if this is a POST request we need to provess the form data
    if request.method == 'POST':
        # create a form instance and populate it with data from the request
        form = ServiceForm(request.POST)

        # check whether it's valid:
        if form.is_valid():
            # process the data in form.cleaned_data as required
            service = Service(name=form.cleaned_data['name'],
                              price=form.cleaned_data['price'],
                              duration=form.cleaned_data['duration'],
                              user=user)
            service.save()

            return HttpResponseRedirect('.')

    # if a GET (or any other method) we'll create a blank form
    else:
        form = ServiceForm()

    return render(request, 'services/services.html',
                  {'user': user,
                   'form': form,
                   'services': services})


class ServiceUpdate(UpdateView):
    model = Service
    template_name = 'services/service_form.html'
    form_class = ServiceForm


class ServiceDelete(DeleteView):
    model = Service
    success_url = reverse_lazy('services:services')

services/templates/services/service_form.html
{% extends 'homepage/base.html' %} {% block content %}
<!-- Translations -->
{% load i18n %}

<div class="row">
  <div class="col-md-2 mx-2 my-2">
    <h2>{% trans "Service" %}</h2>
  </div>
</div>

<div class="col-12 col-md-9 col-xl-8 py-md-3 pl-md-5">
  <form class="form-horizontal" id="add-provider-form" method="POST" action="" role="form">
    {% csrf_token %} {{ form.non_field_errors }}

    <div class="form-row" id="error-service-name">
      <div class="form-group col-md-12">
        <span class="text-danger small">{{ form.name.errors }}</span>
      </div>
    </div>

    <div class="form-row">
      <div class="form-group col-md">
        <label for="{{ form.name.id_for_label }}">{% trans "Name" %}</label>
        {{ form.name }} {% if form.name.help_text %}
        <p class="help">{{ form.name.help_text|safe }}</p>
        {% endif %}
      </div>
    </div>

    <div class="form-row" id="error-service-price">
      <div class="form-group col-md-6">
        <span class="text-danger small">{{ form.price.errors }}</span>
      </div>
      <div class="form-group col-md-6">
        <span class="text-danger small">{{ form.duration.errors }}</span>
      </div>
    </div>

    <div class="form-row">

      <div class="form-group col-md-6">
        <label for="{{ form.price.id_for_label }}">{% trans "Price" %}</label>
        {{ form.price }} {% if form.price.help_text %}
        <p class="help">{{ form.price.help_text|safe }}</p>
        {% endif %}
      </div>

      <div class="form-group col-md-6">
        <label for="{{ form.duration.id_for_label }}">{% trans "Duration" %}</label>
        {{ form.duration }} {% if form.duration.help_text %}
        <p class="help">{{ form.duration.help_text|safe }}</p>
        {% endif %}
      </div>
    </div>

    <button class="btn btn-success my-4" style="width:100px" type="submit">OK</button>
  </form>
</div>

{% endblock %}

services/templates/services/services.html
{% extends 'homepage/base.html' %} {% block content %} {% load static %}
<!-- Translations -->
{% load i18n %}

<div class="row">
  <div class="col-md-2 mx-2 my-2">
    <h2>{% trans "Services" %}</h2>
  </div>
</div>
<div class="col-12 col-md-9 col-xl-8 py-md-3 pl-md-5">
  <form class="form" id="add-service-form" method="POST" action="" role="form">
    {% csrf_token %} {{ form.non_field_errors }}

    <div class="form-row" id="error-service-name">
      <div class="form-group col-md-12">
        <span class="text-danger small">{{ form.name.errors }}</span>
      </div>
    </div>

    <div class="form-row">
      <div class="form-group col-md">
        <label for="{{ form.name.id_for_label }}">{% trans "Name" %}</label>
        {{ form.name }} {% if form.name.help_text %}
        <p class="help">{{ form.name.help_text|safe }}</p>
        {% endif %}
      </div>
    </div>

    <div class="form-row" id="error-service-price">
      <div class="form-group col-md-6">
        <span class="text-danger small">{{ form.price.errors }}</span>
      </div>
      <div class="form-group col-md-6">
        <span class="text-danger small">{{ form.duration.errors }}</span>
      </div>
    </div>

    <div class="form-row">

      <div class="form-group col-md-6">
        <label for="{{ form.price.id_for_label }}">{% trans "Price" %}</label>
        {{ form.price }}
        {% if form.price.help_text %}
        <p class="help">{{ form.price.help_text|safe }}</p>
        {% endif %}
      </div>

      <div class="form-group col-md-6">
        <label for="{{ form.duration.id_for_label }}">{% trans "Duration" %}</label>
        {{ form.duration }} {% if form.duration.help_text %}
        <p class="help">{{ form.duration.help_text|safe }}</p>
        {% endif %}
      </div>
    </div>

    <button class="btn btn-success my-4" style="width:100px" type="submit">OK</button>

  </form>
</div>

{% if user.service_set.all %} {% for service in user.service_set.all %}
<ul class="offset-md-2">
  <li>
    <a href="{% url 'services:service-update' service.id %}">{{ service }}</a>
    <a class="mx-2" href="{% url 'services:service-delete' service.pk %}">
      <i class="far fa-trash-alt fa-fw" id="trash-img"></i>
    </a>
  </li>
</ul>
{% endfor %} {% endif %} {% endblock %}